%define _prefix /opt/lscsoft/lal
%define _mandir %{_prefix}/share/man
%define _sysconfdir %{_prefix}/etc
Name: lal
Version: 6.4.1
Release: 1
Summary: LSC Algorithm Library
License: GPL
Group: LAL
Source: %{name}-%{version}.tar.gz
URL: http://www.lsc-group.phys.uwm.edu/lal
Packager: Jolien Creighton <jolien@uwm.edu>
BuildRoot: %{_tmppath}/%{name}-%{version}-root
BuildRequires: python
Requires: gsl fftw3 libmetaio
Prefix: %{_prefix}

%description
The LSC Algorithm Library for gravitational wave data analysis.
This package contains the shared-object libraries needed to run applications
that use the LAL library.

%package devel
Summary: Files and documentation needed for compiling programs that use LAL
Group: LAL
Requires: %{name} = %{version}
Requires: gsl-devel fftw3-devel fftw3-static libmetaio-devel
%description devel
The LSC Algorithm Library for gravitational wave data analysis.
This package contains files needed build applications that use the LAL library
as well as the documentation for the library.

%prep
%setup -q

%build
source /opt/lscsoft/lscsoft-user-env.sh
nightly_version=
%configure --enable-nightly=${nightly_version:-no} --disable-gcc-flags --disable-debug
%{__make} V=1

%install
%makeinstall

%post
ldconfig

%postun
ldconfig

%clean
[ ${RPM_BUILD_ROOT} != "/" ] && rm -Rf ${RPM_BUILD_ROOT}
rm -Rf ${RPM_BUILD_DIR}/%{name}-%{version}

%files
%defattr(-,root,root)
%{_bindir}/lal-version
%{_libdir}/*.so*
%{_sysconfdir}/lal-user-env.*

%files devel
%defattr(-,root,root)
%{_bindir}/lal-config
%{_libdir}/*a
%{_libdir}/pkgconfig/*
%{_includedir}/lal
%{_datadir}/*
%{_mandir}/man1/lal-config.1*
%{_mandir}/man3/lal.3*


